package healthwatcher.aspects.concurrency;

import healthwatcher.business.employee.EmployeeRecord;
import healthwatcher.model.employee.Employee;
import lib.concurrency.ConcurrencyManager;

import edu.iastate.cs.ptolemy.runtime.*;
import healthwatcher.aspects.concurrency.events.*;

/**
 * This aspect synchronizes a method from employee record using a concurrency manager
 */
@Instantiation(Instantiation.Model.SINGLETON)
@Registration(Registration.Model.IMPLICIT)
public class HWManagedSynchronization {

	private ConcurrencyManager manager = new ConcurrencyManager();
	
	public void handler(InsertEmployeeRecordEvent next) throws Throwable {
		manager.beginExecution(next.employee.getLogin());
		invoke(next);
		manager.endExecution(next.employee.getLogin());
	}
	when InsertEmployeeRecordEvent do handler;
}
