package healthwatcher.aspects.distribution;

import healthwatcher.view.IFacade;
import healthwatcher.view.command.CommandServlet;

import java.rmi.Remote;
import java.rmi.RemoteException;

import lib.distribution.rmi.IteratorRMISourceAdapter;
import lib.distribution.rmi.IteratorRMITargetAdapter;
import lib.distribution.rmi.MethodExecutor;
import lib.exceptions.CommunicationException;
import lib.util.IteratorDsk;
import lib.util.LocalIterator;

import edu.iastate.cs.ptolemy.runtime.*;
import healthwatcher.aspects.distribution.events.*;

/**
 * TODO - describe this file
 * 
 */
@Instantiation(Instantiation.Model.SINGLETON)
@Registration(Registration.Model.IMPLICIT)
public class HWClientDistribution {
	
	/**
	 * Keeps the remote instance
	 */
	protected IRemoteFacade facade = null;
    
    /**
     * Redirects the facade methods call to the distributed instance methods using reflection
     */
	public Object handler (IFacadeMethodEvent next) {
	    Object obj = MethodExecutor.invokeMethod(
		    	getRemoteFacade(), next.name, next.args);
		    if (obj instanceof LocalIterator) {
				IteratorRMITargetAdapter iteratorTA = new IteratorRMITargetAdapter((LocalIterator) obj, 3);
				return new IteratorRMISourceAdapter(iteratorTA, (LocalIterator) obj, 3);
		    }
		    return obj;
	}
	when IFacadeMethodEvent do handler;

	public void handler (IFacadeVoidMethodEvent next) {
	    Object obj = MethodExecutor.invokeMethod(
		    	getRemoteFacade(), next.name, next.args);
		    if (obj instanceof LocalIterator) {
				IteratorRMITargetAdapter iteratorTA = new IteratorRMITargetAdapter((LocalIterator) obj, 3);
				new IteratorRMISourceAdapter(iteratorTA, (LocalIterator) obj, 3);
		    }
	}
	when IFacadeVoidMethodEvent do handler;
    
    /**
     * Retrieves the remote instance, creating if needed
     */
	private synchronized Remote getRemoteFacade() {        
		if (facade == null) {
			try {
	            System.out.println("About to lookup...");
	            facade = (IRemoteFacade) java.rmi.Naming.lookup("//" + healthwatcher.Constants.SERVER_NAME + "/" + healthwatcher.Constants.SYSTEM_NAME);
	            System.out.println("Remote DisqueSaude found");
	        } catch (java.rmi.RemoteException rmiEx) {
	            rmiInitExceptionHandling(rmiEx);
	        } catch (java.rmi.NotBoundException rmiEx) {
	            rmiInitExceptionHandling(rmiEx);
	        } catch (java.net.MalformedURLException rmiEx) {
	            rmiInitExceptionHandling(rmiEx);
	        }
		}
		return facade;
    }
	
    protected void rmiInitExceptionHandling(Throwable exception) {
    	String error =  "<p>****************************************************<br>" +
                 "Error during servlet initialization!<br>" +
                 "The exception message is:<br><dd>" + exception.getMessage() +
                 "<p>You may have to restart the servlet container.<br>" +
                 "*******************************************************";
        System.out.println(error);
    }
}
